// Keeper_Reduced_Guesses.cpp : main project file.
// Final Solution: + BOMB 1.05 New New Idea 1366613 5
#include "stdafx.h"
#include <iostream>
#include <algorithm>
#include <cmath>
using namespace std;
using namespace System;


#define EQ(a, b)				(((a) - (b) < EPS) && ((b) - (a) < EPS))
#define SQR(a)					((a) * (a))



//#define DEBUG_INFO				I hate that part
//#define DEBUG_CALC_INFO			I hate that part



typedef double LD;



const int MAX_CELLS = 600;
const int NOT_KNOWN = - 1;
const int BOMB = 9;

const int SEED = 1366613;
const int GUESS = 4;

const LD EPS = 1e-9;
const LD INF = 1e256;

const int D = 8;
const int delta_row[D] = {+ 1, + 1, + 1,   0,   0, - 1, - 1, - 1};
const int delta_column[D] = {+ 1,   0, - 1, + 1, - 1, + 1,   0, - 1};





int max_solution_size = 0, total_solutions_found = 0;






struct cell
{
	int row, column;
	
	cell(int _row = 0, int _column = 0) : row(_row), column(_column) {}
};


class Mine_Probability_Calculator
{
	
public:
	
	Mine_Probability_Calculator()
	{
		for(int i = 0; i < MAX_CELLS; i ++)
		{
			for(int j = 0; j < MAX_CELLS; j ++)
			{
				Combinations[i][j] = LD(0.0);
			}
		}
		
		Combinations[0][0] = LD(1.0);
		
		for(int i = 1; i < MAX_CELLS; i ++)
		{
			Combinations[i][0] = LD(1.0);
			
			for(int j = 1; j <= i; j ++)
				Combinations[i][j] = Combinations[i - 1][j - 1] + Combinations[i - 1][j];
		}
	}
	
	void Calculate_Equal_to_Bomb_Probabilities(const int & _Rows, const int & _Columns, const int & _Total_Bombs, const int _Table[MAX_CELLS][MAX_CELLS], LD Probabilities[MAX_CELLS][MAX_CELLS])
	{
		Rows = _Rows;
		Columns = _Columns;
		Total_Bombs = _Total_Bombs;
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				Table[row][column] = _Table[row][column];
				Probabilities[row][column] = LD(NOT_KNOWN);
			}
		}
		
		Initialize();
		Find_Cells_Partition_Groups();
		Find_Equations();
		Find_All_Solutions_for_Equations();
		Find_Statistical_Information();
		
		for(int group = 0; group <= Groups_Size; group ++)
			for(int i = 0; i < Cells_in_Group_Size[group]; i ++)
				Probabilities[Cells_in_Group[group][i].row][Cells_in_Group[group][i].column] = Probability_of_Cell_Equal_to_Bomb_in_Group[group];
	}
	
	LD Calculate_No_Further_Guess_Probabilities(const int & _Rows, const int & _Columns, const int & _Total_Bombs, const int & Guess_Row, const int & Guess_Column, const LD & Guess_Bomb_Probability, const int _Table[MAX_CELLS][MAX_CELLS])
	{
	int good = 0, all = 0;;
	LD ret = LD(0.0);
		
		
		Rows = _Rows;
		Columns = _Columns;
		Total_Bombs = _Total_Bombs;
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				Table[row][column] = _Table[row][column];
			}
		}
		
		
		
		
		Table[Guess_Row][Guess_Column] = 0;
		
		Initialize();
		
		Find_Cells_Partition_Groups();
		
		for(int guess = 0; guess <= D; guess ++)
		{
			Table[Guess_Row][Guess_Column] = guess;
			
			Find_Equations();
			Find_All_Solutions_for_Equations();
			
			if(Solutions_Size == 0) continue;
			
			Find_Statistical_Information();
			
			if(0 < Count_Safe_Moves()) good ++;
			
			all ++;
		}
		
		ret = LD(good) * LD(LD(1.0) - Guess_Bomb_Probability) / LD(all);
		
		

		Table[Guess_Row][Guess_Column] = BOMB;
		
		Initialize();
		Find_Cells_Partition_Groups();
		Find_Equations();
		Find_All_Solutions_for_Equations();
		
		if(Solutions_Size == 0) return ret;
			
		Find_Statistical_Information();
		
		if(0 < Count_Safe_Moves()) ret += Guess_Bomb_Probability;

		
//		fprintf(stderr, "%.5lf\n", ret);
		
		return ret;
	}
	
private:
	
struct vector_group_equation
{
	int sum, groups_size;
	int groups[D];
	
	vector_group_equation()
	{
		sum = 0;
		groups_size = 0;
	}
};

struct vector_group_eliminated_equation
{
	int sum, max_sum, not_eliminated, groups_size;
	int groups[D];
	
	vector_group_eliminated_equation()
	{
		sum = 0;
		max_sum = 0;
		not_eliminated = 0;
		groups_size = 0;
	}
};

struct solution
{
	int left_bombs;
	LD size;
	int size_of_group[MAX_CELLS];
	
	solution()
	{
		left_bombs = 0;
		size = LD(0.0);
	}
};
	
	
	
	int Rows, Columns, Total_Bombs, Known_Cells, Known_Bombs, Groups_Size, Equations_Size, Solutions_Size;
	int Cells_in_Equation_Size[MAX_CELLS], Cells_in_Group_Size[MAX_CELLS];
	int Equations_with_Cell_Size[MAX_CELLS][MAX_CELLS], Equations_with_Cell[MAX_CELLS][MAX_CELLS][D];
	int Equations_with_Group_Size[MAX_CELLS], Equations_with_Group[MAX_CELLS][D];
	int Group_of_Not_Known_Cell[MAX_CELLS][MAX_CELLS], Table[MAX_CELLS][MAX_CELLS];
	
	bool Is_Used_Group[MAX_CELLS];
	
	LD Combinations[MAX_CELLS][MAX_CELLS];
	LD Total_Solutions_Size, Solutions[MAX_CELLS][MAX_CELLS];
	LD Probability_of_Cell_Equal_to_Bomb_in_Group[MAX_CELLS];
	
	cell Cells_in_Equation[MAX_CELLS][D], Cells_in_Group[MAX_CELLS][MAX_CELLS];
	
	vector_group_equation Original_Equations[MAX_CELLS];
	vector_group_eliminated_equation Equations[MAX_CELLS];
	
	solution Current_Solution;
	
	
	
	
	
	
	
	void Find_Adjacent_NotKnown(cell adjacent[D], int & adjacent_size, const int & row, const int & column)
	{
	int new_row, new_column;
		
		
		adjacent_size = 0;
		
		for(int d = 0; d < D; d ++)
		{
			new_row = row + delta_row[d];
			new_column = column + delta_column[d];
			
			if(!(0 <= new_row && new_row < Rows)) continue;
			if(!(0 <= new_column && new_column < Columns)) continue;
		
			if(Table[new_row][new_column] != NOT_KNOWN) continue;
			
			adjacent[adjacent_size ++] = cell(new_row, new_column);
		}
	}
	
	int Count_Adjacent_NotKnownBombs(const int & row, const int & column)
	{
	int new_row, new_column, ret = Table[row][column];
		
		for(int d = 0; d < D; d ++)
		{
			new_row = row + delta_row[d];
			new_column = column + delta_column[d];
			
			if(!(0 <= new_row && new_row < Rows)) continue;
			if(!(0 <= new_column && new_column < Columns)) continue;
			
			if(Table[new_row][new_column] != BOMB) continue;
			
			ret --;
		}
		
		return ret;
	}
	
	int Count_Safe_Moves()
	{
	int ret = 0;
		
		for(int group = 0; group <= Groups_Size; group ++)
			if(EQ(Probability_of_Cell_Equal_to_Bomb_in_Group[group], LD(0.0)))
				ret ++;
		
		return ret;
	}
	
	void Initialize()
	{
		Known_Cells = 0;
		Known_Bombs = 0;
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				if(Table[row][column] == BOMB) Known_Bombs ++;
				if(Table[row][column] != NOT_KNOWN) Known_Cells ++;
			}
		}
	}
	
	void Find_Cells_Partition_Groups()
	{
	int adjacent_size, equations_size = 0;
	cell adjacent[D];
		
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				Group_of_Not_Known_Cell[row][column] = NOT_KNOWN;
				Equations_with_Cell_Size[row][column] = 0;
			}
		}
		
		Groups_Size = 0;
		
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				if(Table[row][column] == NOT_KNOWN || Table[row][column] == BOMB) continue;
				
				Find_Adjacent_NotKnown(adjacent, adjacent_size, row, column);
				
				if(adjacent_size == 0) continue;
				
				Cells_in_Equation_Size[equations_size] = 0;
				
				for(int i = 0; i < adjacent_size; i ++)
				{
					Equations_with_Cell[adjacent[i].row][adjacent[i].column][Equations_with_Cell_Size[adjacent[i].row][adjacent[i].column] ++] = equations_size;
					Cells_in_Equation[equations_size][Cells_in_Equation_Size[equations_size] ++] = adjacent[i];
				}
				
				equations_size ++;
			}
		}
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				if(Group_of_Not_Known_Cell[row][column] != NOT_KNOWN || Equations_with_Cell_Size[row][column] == 0) continue;
				
				Group_of_Not_Known_Cell[row][column] = Groups_Size;
				Cells_in_Group_Size[Groups_Size] = 0;
				Cells_in_Group[Groups_Size][Cells_in_Group_Size[Groups_Size] ++] = cell(row, column);
					
				for(int i = 0; i < Equations_with_Cell_Size[row][column]; i ++)
				{
					for(int j = 0; j < Cells_in_Equation_Size[Equations_with_Cell[row][column][i]]; j ++)
					{
						if(Group_of_Not_Known_Cell[Cells_in_Equation[Equations_with_Cell[row][column][i]][j].row][Cells_in_Equation[Equations_with_Cell[row][column][i]][j].column] != NOT_KNOWN) continue;
						if(Equations_with_Cell_Size[row][column] != Equations_with_Cell_Size[Cells_in_Equation[Equations_with_Cell[row][column][i]][j].row][Cells_in_Equation[Equations_with_Cell[row][column][i]][j].column]) continue;
						if(memcmp(Equations_with_Cell[row][column], Equations_with_Cell[Cells_in_Equation[Equations_with_Cell[row][column][i]][j].row][Cells_in_Equation[Equations_with_Cell[row][column][i]][j].column], sizeof(int) * Equations_with_Cell_Size[row][column]) != 0) continue;
						
						Group_of_Not_Known_Cell[Cells_in_Equation[Equations_with_Cell[row][column][i]][j].row][Cells_in_Equation[Equations_with_Cell[row][column][i]][j].column] = Groups_Size;
						Cells_in_Group[Groups_Size][Cells_in_Group_Size[Groups_Size] ++] = Cells_in_Equation[Equations_with_Cell[row][column][i]][j];
					}
				}
				
				Groups_Size ++;
			}
		}
		
		Cells_in_Group_Size[Groups_Size] = 0;
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				if(Group_of_Not_Known_Cell[row][column] == NOT_KNOWN && Table[row][column] == NOT_KNOWN)
				{
					Group_of_Not_Known_Cell[row][column] = Groups_Size;
					Cells_in_Group[Groups_Size][Cells_in_Group_Size[Groups_Size] ++] = cell(row, column);
				}
			}
		}
		
		
		
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "\n\nKnown Cells: %d    Known Bombs: %d\n\n", Known_Cells, Known_Bombs);
		fprintf(stderr, "Answer:\n");
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
				fprintf(stderr, "%3d", Table[row][column]);
			fprintf(stderr, "\n");
		}
		fprintf(stderr, "\n\n");
		system("pause");
		
		
		
		
		for(int i = 0; i <= Groups_Size; i ++)
		{
			fprintf(stderr, "Cells in Group %d: ", i);
			for(int j = 0; j < Cells_in_Group_Size[i]; j ++)
				fprintf(stderr, "(%d, %d) ", Cells_in_Group[i][j].row, Cells_in_Group[i][j].column);
			fprintf(stderr, "\n");
		}
		fprintf(stderr, "\n\n");
		system("pause");
		
		
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
				fprintf(stderr, "%2d ", Group_of_Not_Known_Cell[row][column]);
			fprintf(stderr, "\n");
		}
		fprintf(stderr, "\n\n");
		system("pause");
	#endif
	
	}
	
	void Find_Equations()
	{
	int adjacent_size, index, not_used_groups, max_sum, sum_index, sum_j, not_used_groups_index, not_used_groups_j;
	cell adjacent[D];
		
		
		for(int i = 0; i < Groups_Size; i ++)
		{
			Is_Used_Group[i] = false;
			Equations_with_Group_Size[i] = 0;
		}
		
		Equations_Size = 0;
		
		for(int row = 0; row < Rows; row ++)
		{
			for(int column = 0; column < Columns; column ++)
			{
				if(Table[row][column] == NOT_KNOWN || Table[row][column] == BOMB) continue;
				
				Find_Adjacent_NotKnown(adjacent, adjacent_size, row, column);
				
				if(adjacent_size == 0) continue;
				
				
				Original_Equations[Equations_Size].sum = Count_Adjacent_NotKnownBombs(row, column);
				Original_Equations[Equations_Size].groups_size = 0;
				
				for(int i = 0; i < adjacent_size; i ++)
				{
					if(! Is_Used_Group[Group_of_Not_Known_Cell[adjacent[i].row][adjacent[i].column]])
					{
						Original_Equations[Equations_Size].groups[Original_Equations[Equations_Size].groups_size ++] = Group_of_Not_Known_Cell[adjacent[i].row][adjacent[i].column];
						
						Is_Used_Group[Group_of_Not_Known_Cell[adjacent[i].row][adjacent[i].column]] = true;
					}
				}
				
				for(int i = 0; i < Original_Equations[Equations_Size].groups_size; i ++)
					Is_Used_Group[Original_Equations[Equations_Size].groups[i]] = false;
				
				Equations_Size ++;
			}
		}
		
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "\n\nOriginal Equations:\n");
		for(int i = 0; i < Equations_Size; i ++)
		{
			for(int j = 0; j < Original_Equations[i].groups_size; j ++)
				fprintf(stderr, "g%d ", Original_Equations[i].groups[j]);
			fprintf(stderr, "= %d\n", Original_Equations[i].sum);
		}
		
		fprintf(stderr, "\n\n");
		system("pause");
	#endif
		
		
		for(int i = 0; i < Equations_Size; i ++)
		{
			index = - 1;
			
			for(int j = i; j < Equations_Size; j ++)
			{
				if(Original_Equations[j].sum == 0)
				{
					index = j;
					
					break;
				}
			}
			
			if(0 <= index)
			{
				std :: swap(Original_Equations[i], Original_Equations[index]);
				
				Equations[i].sum = Original_Equations[i].sum;
				Equations[i].max_sum = 0;
				Equations[i].not_eliminated = 0;
				Equations[i].groups_size = 0;
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
				{
					Equations_with_Group[Original_Equations[i].groups[k]][Equations_with_Group_Size[Original_Equations[i].groups[k]] ++] = i;
					
					if(! Is_Used_Group[Original_Equations[i].groups[k]])
					{
						Equations[i].max_sum += Cells_in_Group_Size[Original_Equations[i].groups[k]];
						Equations[i].groups[Equations[i].groups_size ++] = Original_Equations[i].groups[k];
					}
					else
					{
						Equations[i].not_eliminated ++;
					}
				}
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
					Is_Used_Group[Original_Equations[i].groups[k]] = true;
				
				continue;
			}
			
			for(int j = i; j < Equations_Size; j ++)
			{
				not_used_groups = 0;
				
				for(int k = 0; k < Original_Equations[j].groups_size; k ++)
				{
					if(! Is_Used_Group[Original_Equations[j].groups[k]])
					{
						not_used_groups ++;
						
						break;
					}
				}
				
				if(not_used_groups == 0)
				{
					index = j;
					
					break;
				}
			}
			
			if(0 <= index)
			{
				std :: swap(Original_Equations[i], Original_Equations[index]);
				
				Equations[i].sum = Original_Equations[i].sum;
				Equations[i].max_sum = 0;
				Equations[i].not_eliminated = 0;
				Equations[i].groups_size = 0;
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
				{
					Equations_with_Group[Original_Equations[i].groups[k]][Equations_with_Group_Size[Original_Equations[i].groups[k]] ++] = i;
					
					if(! Is_Used_Group[Original_Equations[i].groups[k]])
					{
						Equations[i].max_sum += Cells_in_Group_Size[Original_Equations[i].groups[k]];
						Equations[i].groups[Equations[i].groups_size ++] = Original_Equations[i].groups[k];
					}
					else
					{
						Equations[i].not_eliminated ++;
					}
				}
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
					Is_Used_Group[Original_Equations[i].groups[k]] = true;
				
				continue;
			}
			
			for(int j = i; j < Equations_Size; j ++)
			{
				max_sum = 0;
				
				for(int k = 0; k < Original_Equations[j].groups_size; k ++)
				{
					max_sum += Cells_in_Group_Size[Original_Equations[j].groups[k]];
				}
				
				if(max_sum == Original_Equations[j].sum)
				{
					index = j;
					
					break;
				}
			}
			
			if(0 <= index)
			{
				std :: swap(Original_Equations[i], Original_Equations[index]);
				
				Equations[i].sum = Original_Equations[i].sum;
				Equations[i].max_sum = 0;
				Equations[i].not_eliminated = 0;
				Equations[i].groups_size = 0;
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
				{
					Equations_with_Group[Original_Equations[i].groups[k]][Equations_with_Group_Size[Original_Equations[i].groups[k]] ++] = i;
					
					if(! Is_Used_Group[Original_Equations[i].groups[k]])
					{
						Equations[i].max_sum += Cells_in_Group_Size[Original_Equations[i].groups[k]];
						Equations[i].groups[Equations[i].groups_size ++] = Original_Equations[i].groups[k];
					}
					else
					{
						Equations[i].not_eliminated ++;
					}
				}
				
				for(int k = 0; k < Original_Equations[i].groups_size; k ++)
					Is_Used_Group[Original_Equations[i].groups[k]] = true;
				
				continue;
			}
			
			
			index = i;
			
			for(int j = i + 1; j < Equations_Size; j ++)
			{
				sum_index = 0;
				sum_j = 0;
				not_used_groups_index = 0;
				not_used_groups_j = 0;
				
				for(int k = 0; k < Original_Equations[index].groups_size; k ++)
				{
					if(! Is_Used_Group[Original_Equations[index].groups[k]])
					{
						sum_index += Cells_in_Group_Size[Original_Equations[index].groups[k]];
						not_used_groups_index ++;
					}
				}
				
				for(int k = 0; k < Original_Equations[j].groups_size; k ++)
				{
					if(! Is_Used_Group[Original_Equations[j].groups[k]])
					{
						sum_j += Cells_in_Group_Size[Original_Equations[j].groups[k]];
						not_used_groups_j ++;
					}
				}
				
				if(not_used_groups_j < not_used_groups_index)
				{
					index = j;
					
					continue;
				}
				
				if(not_used_groups_j == not_used_groups_index)
				{
					if(Original_Equations[j].sum < Original_Equations[index].sum)
					{
						index = j;
						
						continue;
					}
					
					if(Original_Equations[j].sum == Original_Equations[index].sum)
					{
						if(sum_j < sum_index)
						{
							index = j;
							
							continue;
						}
					}
				}
			}
			
			std :: swap(Original_Equations[i], Original_Equations[index]);
			
			Equations[i].sum = Original_Equations[i].sum;
			Equations[i].max_sum = 0;
			Equations[i].not_eliminated = 0;
			Equations[i].groups_size = 0;
			
			for(int k = 0; k < Original_Equations[i].groups_size; k ++)
			{
				Equations_with_Group[Original_Equations[i].groups[k]][Equations_with_Group_Size[Original_Equations[i].groups[k]] ++] = i;
				
				if(! Is_Used_Group[Original_Equations[i].groups[k]])
				{
					Equations[i].max_sum += Cells_in_Group_Size[Original_Equations[i].groups[k]];
					Equations[i].groups[Equations[i].groups_size ++] = Original_Equations[i].groups[k];
				}
				else
				{
					Equations[i].not_eliminated ++;
				}
			}
		
			for(int k = 0; k < Original_Equations[i].groups_size; k ++)
				Is_Used_Group[Original_Equations[i].groups[k]] = true;
		}
		
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "\n\nSorted New Equations:\n");
		for(int i = 0; i < Equations_Size; i ++)
		{
			for(int j = 0; j < Original_Equations[i].groups_size; j ++)
				fprintf(stderr, "g%d ", Original_Equations[i].groups[j]);
			fprintf(stderr, "= %d\n", Original_Equations[i].sum);
		}
		
		fprintf(stderr, "\n\n");
		system("pause");
		
		
		
		fprintf(stderr, "\n\nEquations After Elimination:\n");
		for(int i = 0; i < Equations_Size; i ++)
		{
			for(int j = 0; j < Equations[i].groups_size; j ++)
				fprintf(stderr, "g%d ", Equations[i].groups[j]);
			fprintf(stderr, "= %d\n", Equations[i].sum);
		}
		
		fprintf(stderr, "\n\n");
		system("pause");
		
		
		for(int i = 0; i < Groups_Size; i ++)
		{
			fprintf(stderr, "Equations with Group %d: ", i);
			for(int j = 0; j < Equations_with_Group_Size[i]; j ++)
				fprintf(stderr, "%2d ", Equations_with_Group[i][j]);
			fprintf(stderr, "\n");
		}
		fprintf(stderr, "\n\n");
		system("pause");
	#endif
	}
	
	void Recursion(int equation_index, int group_index)
	{
	bool is_feasible;
	int group, minimum, maximum;
		

//		if(MAX_S < Solutions_Size) return;
		
		if(equation_index == Equations_Size)
		{
			if(Cells_in_Group_Size[Groups_Size] < Current_Solution.left_bombs)
			{
				return;
			}
			
			Current_Solution.size *= Combinations[Cells_in_Group_Size[Groups_Size]][Current_Solution.left_bombs];
			
			for(int i = 0; i < Groups_Size; i ++)
				Solutions[i][Current_Solution.size_of_group[i]] += Current_Solution.size;
			
			Solutions[Groups_Size][Current_Solution.left_bombs] += Current_Solution.size;
			
		#ifdef DEBUG_CALC_INFO
			fprintf(stderr, "Solution:    Left Bombs: %d    Size: %.3lf\n", Current_Solution.left_bombs, Current_Solution.size);
			for(int i = 0; i < Groups_Size; i ++)
				fprintf(stderr, "g%d=%d  ", i, Current_Solution.size_of_group[i]);
			fprintf(stderr, "\n");
		#endif
			
			Solutions_Size ++;
			Total_Solutions_Size += Current_Solution.size;
			
			Current_Solution.size /= Combinations[Cells_in_Group_Size[Groups_Size]][Current_Solution.left_bombs];
			
			return;
		}
		
		if(Equations[equation_index].max_sum < Equations[equation_index].sum)
		{
			return;
		}
		
		if(Equations[equation_index].groups_size == 0)
		{
			if(Equations[equation_index].sum == 0)
				Recursion(equation_index + 1, 0);
			
			return;
		}
		
		group = Equations[equation_index].groups[group_index];
		
		Equations[equation_index].max_sum -= Cells_in_Group_Size[group];
		
		minimum = std :: max(0, Equations[equation_index].sum - Equations[equation_index].max_sum);
		maximum = std :: min(Current_Solution.left_bombs, std :: min(Equations[equation_index].sum, Cells_in_Group_Size[group]));
		
		for(int size_of_group = minimum; size_of_group <= maximum; size_of_group ++)
		{
			is_feasible = true;
			
			Current_Solution.left_bombs -= size_of_group;
			Current_Solution.size *= Combinations[Cells_in_Group_Size[group]][size_of_group];
			Current_Solution.size_of_group[group] = size_of_group;
			
			for(int i = 0; i < Equations_with_Group_Size[group]; i ++)
			{
				Equations[Equations_with_Group[group][i]].sum -= size_of_group;
				Equations[Equations_with_Group[group][i]].not_eliminated --;
				
				if(Equations[Equations_with_Group[group][i]].sum < 0)
				{
					is_feasible = false;
				}
				
				if(Equations[Equations_with_Group[group][i]].not_eliminated == 0 && Equations[Equations_with_Group[group][i]].max_sum < Equations[Equations_with_Group[group][i]].sum)
				{
					is_feasible = false;
				}
			}
			
			if(is_feasible)
			{
				if(group_index + 1 == Equations[equation_index].groups_size)
				{
					Recursion(equation_index + 1, 0);
				}
				else
				{
					Recursion(equation_index, group_index + 1);
				}
			}
			
			Current_Solution.left_bombs += size_of_group;
			Current_Solution.size /= Combinations[Cells_in_Group_Size[group]][size_of_group];
			Current_Solution.size_of_group[group] = NOT_KNOWN;
			
			for(int i = 0; i < Equations_with_Group_Size[group]; i ++)
			{
				Equations[Equations_with_Group[group][i]].sum += size_of_group;
				Equations[Equations_with_Group[group][i]].not_eliminated ++;
			}
		}
		
		Equations[equation_index].max_sum += Cells_in_Group_Size[group];
	}
	
	void Find_All_Solutions_for_Equations()
	{
		Current_Solution.left_bombs = Total_Bombs - Known_Bombs;
		Current_Solution.size = LD(1.0);
		Solutions_Size = 0;
		Total_Solutions_Size = LD(0.0);
		
		for(int i = 0; i <= Groups_Size; i ++)
		{
			Current_Solution.size_of_group[i] = NOT_KNOWN;
			
			for(int j = 0; j <= Cells_in_Group_Size[i]; j ++)
			{
				Solutions[i][j] = LD(0.0);
			}
		}
		
		for(int i = 0; i <= Current_Solution.left_bombs; i ++)
			Solutions[Groups_Size][i] = LD(0.0);
		
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "Solutions:\n");
	#endif
		
		
		
		Recursion(0, 0);
		
		
		max_solution_size = std :: max(max_solution_size, Solutions_Size);
		total_solutions_found += Solutions_Size;
	
		
		
	//	fprintf(stderr, "%d\n", Solutions_Size);
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "\n\n");
		system("pause");
	#endif
	}
	
	void Find_Statistical_Information()
	{
		if(Solutions_Size == 0)
			return;
		
		for(int group = 0; group <= Groups_Size; group ++)
		{
			Probability_of_Cell_Equal_to_Bomb_in_Group[group] = LD(0.0);
		}
		
		for(int group = 0; group <= Groups_Size; group ++)
		{
			if(Cells_in_Group_Size[group] == 0)
			{
				Probability_of_Cell_Equal_to_Bomb_in_Group[group] = INF;
				
				continue;
			}
			
			for(int i = 0; i <= Cells_in_Group_Size[group]; i ++)
				Probability_of_Cell_Equal_to_Bomb_in_Group[group] += LD(Solutions[group][i]) * LD(LD(i) / LD(Cells_in_Group_Size[group]));
			
			Probability_of_Cell_Equal_to_Bomb_in_Group[group] /= LD(Total_Solutions_Size);
		}
		
		
	#ifdef DEBUG_CALC_INFO
		fprintf(stderr, "Probabilitis of Cells Equal to BOMB in Groups:\n");
		for(int i = 0; i <= Groups_Size; i ++)
			fprintf(stderr, "Group %d: %.10lf\n", i, Probability_of_Cell_Equal_to_Bomb_in_Group[i]);
		fprintf(stderr, "\n\n");
		system("pause");
	#endif
	}
	
	
};









int Rows, Columns, Score, Total_Bombs, Known_Cells, Known_Bombs, Ask_Queue_Size;
int Table[MAX_CELLS][MAX_CELLS];
bool Is_Cell_in_Ask_Queue[MAX_CELLS][MAX_CELLS];
cell Ask_Queue[MAX_CELLS];
LD Probability_of_Cell_Equal_to_Bomb[MAX_CELLS][MAX_CELLS];
Mine_Probability_Calculator Probability_Calculator;




LD expected_score = LD(0.0);




int Ask(Honey :: Play ^p, int row, int column)
{
int ret = p -> open(row, column);
	
	if(ret < 0) 
	{
		ret = BOMB;

		Score ++;
	}
	
	return ret;
}

void Read(Honey :: Play ^p)
{
//ifstream in("keeper.in");
FILE * in = fopen("keeper.in", "r");
int test_number;
	
//	in >> test_number;
	fscanf(in, "%d", & test_number);	

//	fprintf(stderr, "Test Number: %d\n", test_number);

	p -> startGame(test_number);
	Rows = p -> getRows();
	Columns = p -> getColumns();
	Total_Bombs = p -> getHoneyPots();

//	fprintf(stderr, "R: %d   C: %d   T: %d\n", Rows, Columns, Total_Bombs);
}

void Initialize()
{
	srand(SEED);
	
	Known_Cells = 0;
	Known_Bombs = 0;
	Ask_Queue_Size = 0;

	Score = 0;
	
	for(int i = 0; i < MAX_CELLS; i ++)
	{
		for(int j = 0; j < MAX_CELLS; j ++)
		{
			Table[i][j] = NOT_KNOWN;
			Is_Cell_in_Ask_Queue[i][j] = false;
		}
	}
}

LD Find_Minimum(const LD probabilities[MAX_CELLS][MAX_CELLS])
{
LD ret = INF;
	
	
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(EQ(probabilities[row][column], LD(NOT_KNOWN))) continue;
			
			ret = std :: min(ret, probabilities[row][column]);
		}
	}
	
	return ret;
}

void Choose_Best_Cell()
{
cell guess_cell(- 1, - 1);
LD best_probablity = - INF, current_probablity, minimum = Find_Minimum(Probability_of_Cell_Equal_to_Bomb);
bool moves_with_no_risk = false;
	
	//	fprintf(stderr, "MAKE A GUESS!!!!!\n");
	
	
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(0.0)))
			{
				Ask_Queue[Ask_Queue_Size ++] = cell(row, column);
				Is_Cell_in_Ask_Queue[row][column] = true;
				
				moves_with_no_risk = true;
			}
			
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(1.0)))
			{
				Table[row][column] = BOMB;
				
				Known_Cells ++;
				Known_Bombs ++;
			}
		}
	}
	
	
	if(moves_with_no_risk)
		return;
	
	if(Known_Cells == Rows * Columns)
		return;
	
	
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(NOT_KNOWN))) continue;
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(1.0))) continue;
			if(! EQ(Probability_of_Cell_Equal_to_Bomb[row][column], minimum)) continue;
			
			if(guess_cell.row < 0 || guess_cell.column < 0)
			{
				guess_cell = cell(row, column);
			}
	
			if(rand() % GUESS)
			{
				guess_cell = cell(row, column);
			}
		}
	}




/*
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(NOT_KNOWN))) continue;
			if(EQ(Probability_of_Cell_Equal_to_Bomb[row][column], LD(1.0))) continue;
			if(! EQ(Probability_of_Cell_Equal_to_Bomb[row][column], minimum)) continue;
//			if(LD(1.05) * minimum < Probability_of_Cell_Equal_to_Bomb[row][column]) continue;
			
			
			current_probablity = Probability_Calculator.Calculate_No_Further_Guess_Probabilities(Rows, Columns, Total_Bombs, row, column, Probability_of_Cell_Equal_to_Bomb[row][column], Table);
			
			if(EQ(current_probablity, best_probablity))
			{
				if(rand() % 5 == 0)
				{
					guess_cell = cell(row, column);
				}
			}
			else
			if(best_probablity < current_probablity)
			{
				guess_cell = cell(row, column);
				
				best_probablity = current_probablity;
			}
			
		#ifdef DEBUG_INFO
			fprintf(stderr, "Probability of Not Bomb and Stop Further Guessing of Cell (%d, %d): %.5lf\n\n\n", row, column, current_probablity);
			system("pause");
		#endif
		}
	}
*/
	
	
	
//	fprintf(stderr, "Guessed: (%d , %d)\n", guess_cell.row, guess_cell.column);
//	system("pause");
	
//	scanf("%d %d", & guess_cell.row, & guess_cell.column);
	
	expected_score += Probability_of_Cell_Equal_to_Bomb[guess_cell.row][guess_cell.column];
	
	Ask_Queue[Ask_Queue_Size ++] = guess_cell;
	Is_Cell_in_Ask_Queue[guess_cell.row][guess_cell.column] = true;
}

void Find_Probabilities()
{
bool moves_with_no_risk = false;
	
	
	Probability_Calculator.Calculate_Equal_to_Bomb_Probabilities(Rows, Columns, Total_Bombs, Table, Probability_of_Cell_Equal_to_Bomb);
	
	
#ifdef DEBUG_INFO
	fprintf(stderr, "\n\nKnown Cells: %d    Known Bombs: %d\n\n", Known_Cells, Known_Bombs);
	fprintf(stderr, "Answer:\n");
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
			fprintf(stderr, "%3d", Table[row][column]);
		fprintf(stderr, "\n");
	}
	fprintf(stderr, "\n\n");
	system("pause");
		
	
	
	
	fprintf(stderr, "Probabilitis of Cells Equal to BOMB:\n");
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
			fprintf(stderr, "%7.3lf ", Probability_of_Cell_Equal_to_Bomb[row][column]);
		fprintf(stderr, "\n");
	}
	fprintf(stderr, "\n\n");
	system("pause");
#endif
}

void Fix_Probabilities()
{
LD probability = LD(Total_Bombs - Known_Bombs) / LD(Rows * Columns - Known_Cells);
	
	
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(Table[row][column] == NOT_KNOWN)
			{
				Probability_of_Cell_Equal_to_Bomb[row][column] = probability;
			}
			else
			{
				Probability_of_Cell_Equal_to_Bomb[row][column] = LD(- 1.0);
			}
		}
	}
}

void Solve_Random()
{
int n = rand() % (Rows * Columns - Known_Cells);
cell random_cell;
	
	
	for(int row = 0; row < Rows; row ++)
	{
		for(int column = 0; column < Columns; column ++)
		{
			if(Table[row][column] == NOT_KNOWN)
			{
				if(n == 0)
				{
					random_cell = cell(row, column);
					
					Ask_Queue[Ask_Queue_Size ++] = random_cell;
					
					Is_Cell_in_Ask_Queue[random_cell.row][random_cell.column] = true;
					
					
				#ifdef DEBUG_INFO
					fprintf(stderr, "Open Cell: (%d, %d)\n\n", random_cell.row, random_cell.column);
				//	system("pause");
				#endif
					
					
					return;
				}
				
				n --;
			}
		}
	}
	
	
//	fprintf(stderr, "\n\nFUCK!!!!!!!!!!!!!!!!!!!!!!!!!!\n\n");
//	while(1);
}

void Open_Cells_in_Ask_Queue(Honey :: Play ^p)
{
cell c;
	
	
	for(int top = 0; top < Ask_Queue_Size; top ++)
	{
		c = Ask_Queue[top];
		
		Table[c.row][c.column] =  Ask(p, c.row, c.column);
		
		Known_Cells ++;
		
		if(Table[c.row][c.column] == BOMB) Known_Bombs ++;
		
		if(Table[c.row][c.column] != 0) continue;
		
		for(int d = 0; d < D; d ++)
		{
			Ask_Queue[Ask_Queue_Size] = cell(c.row + delta_row[d], c.column + delta_column[d]);
			
			if(!(0 <= Ask_Queue[Ask_Queue_Size].row && Ask_Queue[Ask_Queue_Size].row < Rows)) continue;
			if(!(0 <= Ask_Queue[Ask_Queue_Size].column && Ask_Queue[Ask_Queue_Size].column < Columns)) continue;
			if(Is_Cell_in_Ask_Queue[Ask_Queue[Ask_Queue_Size].row][Ask_Queue[Ask_Queue_Size].column]) continue;
			if(Table[Ask_Queue[Ask_Queue_Size].row][Ask_Queue[Ask_Queue_Size].column] != NOT_KNOWN) continue;
			
			Is_Cell_in_Ask_Queue[Ask_Queue[Ask_Queue_Size].row][Ask_Queue[Ask_Queue_Size].column] = true;
			
			Ask_Queue_Size ++;
		}
	}
	
	Ask_Queue_Size = 0;
}

void Solve(Honey :: Play ^p)
{
//	Ask_Queue[Ask_Queue_Size ++] = cell(0, 0);
//	Is_Cell_in_Ask_Queue[0][0] = true;
//	Open_Cells_in_Ask_Queue();

	if(Rows * Columns == Total_Bombs)
	{
		for(int row = 0; row < Rows; row ++)
			for(int column = 0; column < Columns; column ++)
				Table[row][column] = BOMB;
		
		
		return;
	}

	while(Known_Cells != Rows * Columns)
	{
		if(Total_Bombs == 0 || Known_Cells == Known_Bombs)
		{
//			Fix_Probabilities();
			Solve_Random();
		}
		else
		{
			Find_Probabilities();
			Choose_Best_Cell();
		}
		
//		Choose_Best_Cell();
		
		Open_Cells_in_Ask_Queue(p);
	}
}







int main(array<System::String ^> ^args)
{
	Honey :: Play ^p = gcnew Honey :: Play();
//	p->Url = L"http://konkurs.musala.com/HoneyKeeper/Play.asmx";
	p -> CookieContainer = gcnew System :: Net :: CookieContainer();
	
	Read(p);
	
	Initialize();

//	fprintf(stderr, "Done Initializing\n");
	
	Solve(p);

//	fprintf(stderr, "Done Solving\n");
	
	for(int i = 0; i < Rows; i ++)
	{
		for(int j = 0; j < Columns; j ++)
		{
			if(Table[i][j] == BOMB) Table[i][j] = - 1;

			Console :: Write(Table[i][j]);
		}
		Console :: WriteLine();
	}
	
	p -> finishGame();

//	fprintf(stderr, "Score: %d\n", Score);
	
//	fprintf(stderr, "Max Sol Size: %d    Total Sols: %d   Expected Score: %.5lf\n", max_solution_size, total_solutions_found, expected_score);


    return 0;
}
